OSDN Git Service

* gcc_release (build_sources): Use two new variables EXPORTTAG and
[pf3gnuchains/gcc-fork.git] / maintainer-scripts / gcc_release
1 #! /bin/sh
2
3 ########################################################################
4 #
5 # File:   gcc_release
6 # Author: Jeffrey Law, Bernd Schmidt, Mark Mitchell
7 # Date:   2001-05-25
8 #
9 # Contents:
10 #   Script to create a GCC release.
11 #
12 # Copyright (c) 2001, 2002 Free Software Foundation.
13 #
14 # This file is part of GCC.
15 #
16 # GCC is free software; you can redistribute it and/or modify
17 # it under the terms of the GNU General Public License as published by
18 # the Free Software Foundation; either version 2, or (at your option)
19 # any later version.
20 #
21 # GCC is distributed in the hope that it will be useful,
22 # but WITHOUT ANY WARRANTY; without even the implied warranty of
23 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
24 # GNU General Public License for more details.
25 #
26 # You should have received a copy of the GNU General Public License
27 # along with GCC; see the file COPYING.  If not, write to
28 # the Free Software Foundation, 59 Temple Place - Suite 330,
29 # Boston, MA 02111-1307, USA.
30 #
31 ########################################################################
32
33 ########################################################################
34 # Notes
35 ########################################################################
36
37 # Here is an example usage of this script, to create a GCC 3.0.2
38 # prerelease:
39 #
40 #   gcc_release -r 3.0.2
41 #
42 # This script will automatically use the head of the release branch
43 # to generate the release.
44
45 ########################################################################
46 # Functions
47 ########################################################################
48
49 # Issue the error message given by $1 and exit with a non-zero
50 # exit code.
51
52 error() {
53     echo "gcc_release: error: $1"
54     exit 1
55 }
56
57 # Issue the informational message given by $1.
58
59 inform() {
60     echo "gcc_release: $1"
61 }
62
63 # Issue a usage message explaining how to use this script.
64
65 usage() {
66 cat <<EOF
67 gcc_release -r release [-f] [further options]
68 gcc_release -s name:cvsbranch [further options]
69
70 Options:
71
72   -r release           Version of the form X.Y or X.Y.Z.
73   -s name:cvsbranch    Create a snapshot, not a real release.
74
75   -d destination       Local working directory where we will build the release
76                        (default=${HOME}).
77   -f                   Create a final release (and update ChangeLogs,...).
78   -l                   Indicate that we are running on gcc.gnu.org.
79   -p previous-tarball  Location of a previous tarball (to generate diff files).
80   -t tag               Tag to mark the release in CVS.
81   -u username          Username for upload operations.
82 EOF
83     exit 1
84 }
85
86 # Change to the directory given by $1.
87
88 changedir() {
89   cd $1 || \
90     error "Could not change directory to $1"
91 }
92
93 # Each of the arguments is a directory name, relative to the top
94 # of the source tree.  Return another name for that directory, relative
95 # to the working directory.
96
97 adjust_dirs() {
98   for x in $@; do
99     echo `basename ${SOURCE_DIRECTORY}`/$x
100   done
101 }
102
103 # Build the source tree that will be the basis for the release
104 # in ${WORKING_DIRECTORY}/gcc-${RELEASE}.
105
106 build_sources() {
107   # If the WORKING_DIRECTORY already exists, do not risk destroying it.
108   if [ -r ${WORKING_DIRECTORY} ]; then
109     error "\`${WORKING_DIRECTORY}' already exists"
110   fi
111   # Create the WORKING_DIRECTORY.
112   mkdir "${WORKING_DIRECTORY}" \
113     || error "Could not create \`${WORKING_DIRECTORY}'"
114   changedir "${WORKING_DIRECTORY}"
115
116   # If this is a final release, make sure that the ChangeLogs
117   # and version strings are updated.
118   if [ ${FINAL} -ne 0 ]; then
119     inform "Updating ChangeLogs and version files"
120
121     ${CVS} co -d "`basename ${SOURCE_DIRECTORY}`" \
122            -r ${CVSBRANCH} gcc || \
123            error "Could not check out release sources"
124     for x in `find ${SOURCE_DIRECTORY} -name ChangeLog`; do
125       # Update this ChangeLog file only if it does not yet contain the
126       # entry we are going to add.  (This is a safety net for repeated
127       # runs of this script for the same release.)
128       if ! grep "GCC ${RELEASE} released." ${x} > /dev/null ; then       
129         cat - ${x} > ${x}.new <<EOF
130 ${LONG_DATE}  Release Manager
131
132         * GCC ${RELEASE} released.
133
134 EOF
135         mv ${x}.new ${x} || \
136             error "Could not update ${x}"
137         (changedir `dirname ${x}` && \
138             ${CVS} ci -m 'Mark ChangeLog' `basename ${x}`) || \
139             error "Could not commit ${x}"
140       fi
141     done
142
143     # Update `gcc/version.c'.
144     for x in gcc/version.c; do 
145       y=`basename ${x}`
146       (changedir `dirname ${SOURCE_DIRECTORY}/${x}` && \
147           sed -e 's|version_string\[\] = \".*\"|version_string\[\] = \"'${RELEASE}'\"|g' < ${y} > ${y}.new && \
148           mv ${y}.new ${y} && \
149           ${CVS} ci -m 'Update version' ${y}) || \
150           error "Could not update ${x}"
151     done
152
153     # Make sure we tag the sources for a final release.
154     TAG="gcc_`echo ${RELEASE} | tr . _`_release"
155
156     rm -rf ${SOURCE_DIRECTORY}
157   fi
158
159   # Tag the sources.
160   if [ -n "${TAG}" ]; then
161     inform "Tagging sources as ${TAG}"
162     ${CVS} rtag -r ${CVSBRANCH} -F ${TAG} gcc || \
163       error "Could not tag sources"
164     EXPORTTAG="-r${TAG}"
165     EXPORTDATE=""
166   else
167     if [ ${CVSBRANCH} != "HEAD" ]; then
168       EXPORTTAG="-r${CVSBRANCH}"
169     else
170       # HEAD is the default branch, no need to specify it.
171       EXPORTTAG=""
172     fi
173     EXPORTDATE="-D`date -u +"%Y-%m-%d %H:%M"` UTC"
174   fi
175
176   # Export the current sources.
177   inform "Retrieving sources (cvs export ${EXPORTTAG} ${EXPORTDATE} gcc)"
178
179   if [ -z "${EXPORTTAG}" ]; then
180     ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
181        "${EXPORTDATE}" gcc || \
182       error "Could not retrieve sources"
183   elif [ -z "${EXPORTDATE}" ]; then
184     ${CVS} export -d "`basename ${SOURCE_DIRECTORY}`" \
185        "${EXPORTTAG}" gcc || \
186       error "Could not retrieve sources"
187   else
188     error "Cannot specify -r and -D at the same time"
189   fi
190
191   # Run gcc_update on them to set up the timestamps nicely.
192   changedir "gcc-${RELEASE}"
193   contrib/gcc_update --touch
194
195   # Obtain some documentation files from the wwwdocs module.
196   inform "Retrieving HTML documentation"
197   changedir "${WORKING_DIRECTORY}"
198   for x in bugs faq; do
199     (${CVS} export -r HEAD wwwdocs/htdocs/${x}.html && \
200      cp ${WORKING_DIRECTORY}/wwwdocs/htdocs/${x}.html \
201         ${SOURCE_DIRECTORY}) || \
202       error "Could not retrieve ${x}.html"
203   done
204
205   inform "Generating plain-text documentation from HTML"
206   changedir "${SOURCE_DIRECTORY}"
207   for file in *.html; do
208     newfile=`echo $file | sed -e 's/.html//' | tr "[:lower:]" "[:upper:]"`
209     (${ENV} TERM=vt100 lynx -dump $file \
210        | sed -e "s#file://localhost`/bin/pwd`\(.*\)#http://gcc.gnu.org\1#g" \
211        > $newfile) || \
212      error "Could not generate text-only version of ${file}"
213   done
214
215   # For a prerelease or real release, we need to generate additional
216   # files not present in CVS.
217   changedir "${SOURCE_DIRECTORY}"
218   if [ $SNAPSHOT -ne 1 ]; then
219     # Generate the documentation.
220     inform "Building install docs"
221     SOURCEDIR=${SOURCE_DIRECTORY}/gcc/doc
222     DESTDIR=${SOURCE_DIRECTORY}/INSTALL
223     export SOURCEDIR
224     export DESTDIR
225     ${SOURCE_DIRECTORY}/gcc/doc/install.texi2html
226
227     # Regenerate the NEWS file.
228     contrib/gennews > gcc/NEWS || \
229       error "Could not regenerate NEWS files"
230
231     # Now, we must build the compiler in order to create any generated
232     # files that are supposed to go in the source directory.  This is
233     # also a good sanity check to make sure that the release builds
234     # on at least one platform.
235     inform "Building compiler"
236     OBJECT_DIRECTORY=../objdir
237     contrib/gcc_build -d ${SOURCE_DIRECTORY} -o ${OBJECT_DIRECTORY} build || \
238       error "Could not rebuild GCC"
239
240     # Regenerate the Fotran NEWS and BUGS files.
241     (cd ${OBJECT_DIRECTORY}/gcc && make f77.rebuilt) || \
242       error "Could not regenerate Fortran NEWS and BUGS files"
243   fi
244
245   # Move message catalogs to source directory.
246   mv ../objdir/gcc/po/*.gmo gcc/po/
247
248   # Create a `.brik' file to use for checking the validity of the
249   # release.
250   changedir "${SOURCE_DIRECTORY}"
251   BRIK_FILE=`mktemp /tmp/gcc_release.XXXXXXX`
252   ((find . -type f | sort > $BRIK_FILE) && \
253        brik -Gb -f ${BRIK_FILE} > .brik && \
254        rm ${BRIK_FILE}) || \
255      error "Could not compute brik checksum"
256 }
257
258 # Buid a single tarfile.  The first argument is the name of the name
259 # of the tarfile to build, without any suffixes.  They will be added
260 # automatically.  The rest of the arguments are the files or
261 # directories to include.
262
263 build_tarfile() {
264   # Get the name of the destination tar file.
265   TARFILE="$1.tar.bz2"
266   shift
267
268   # Build the tar file itself.
269   (${TAR} cf - "$@" | ${BZIP2} > ${TARFILE}) || \
270     error "Could not build tarfile"
271   FILE_LIST="${FILE_LIST} ${TARFILE}"
272 }
273
274 # Build the various tar files for the release.
275
276 build_tarfiles() {
277   inform "Building tarfiles"
278
279   changedir "${WORKING_DIRECTORY}"
280
281   # The GNU Coding Standards specify that all files should
282   # world readable.
283   chmod -R a+r ${SOURCE_DIRECTORY}
284   # And that all directories have mode 777.
285   find ${SOURCE_DIRECTORY} -type d -exec chmod 777 {} \;
286  
287   # Build one huge tarfile for the entire distribution.
288   build_tarfile gcc-${RELEASE} `basename ${SOURCE_DIRECTORY}`
289
290   # Now, build one for each of the languages.
291   build_tarfile gcc-ada-${RELEASE} ${ADA_DIRS}
292   build_tarfile gcc-g++-${RELEASE} ${CPLUSPLUS_DIRS}
293   build_tarfile gcc-g77-${RELEASE} ${FORTRAN_DIRS}
294   build_tarfile gcc-java-${RELEASE} ${JAVA_DIRS}
295   build_tarfile gcc-objc-${RELEASE} ${OBJECTIVEC_DIRS}
296   build_tarfile gcc-testsuite-${RELEASE} ${TESTSUITE_DIRS}
297    
298   # The core is everything else.
299   EXCLUDES=""
300   for x in ${ADA_DIRS} ${CPLUSPLUS_DIRS} ${FORTRAN_DIRS} \
301            ${JAVA_DIRS} ${OBJECTIVEC_DIRS} ${TESTSUITE_DIRS}; do
302     EXCLUDES="${EXCLUDES} --exclude $x"
303   done
304   build_tarfile gcc-core-${RELEASE} ${EXCLUDES} \
305     `basename ${SOURCE_DIRECTORY}`
306 }
307
308 # Build .gz files.
309 build_gzip() {
310   for f in ${FILE_LIST}; do
311     target=${f%.bz2}.gz
312     (${BZIP2} -d -c $f | ${GZIP} > ${target}) || error "Could not create ${target}"
313   done
314 }
315
316 # Build diffs against an old release.
317 build_diffs() {
318   old_dir=${1%/*}
319   old_file=${1##*/}
320   old_vers=${old_file%.tar.bz2}
321   old_vers=${old_vers#gcc-}
322   inform "Building diffs against version $old_vers"
323   for f in gcc gcc-ada gcc-g++ gcc-g77 gcc-java gcc-objc gcc-testsuite gcc-core; do
324     old_tar=${old_dir}/${f}-${old_vers}.tar.bz2
325     new_tar=${WORKING_DIRECTORY}/${f}-${RELEASE}.tar.bz2
326     if [ ! -e $old_tar ]; then
327       inform "$old_tar not found; not generating diff file"
328     elif [ ! -e $new_tar ]; then
329       inform "$new_tar not found; not generating diff file"
330     else
331       build_diff $old_tar gcc-${old_vers} $new_tar gcc-${RELEASE} \
332         ${f}-${old_vers}-${RELEASE}.diff.bz2
333     fi
334   done
335 }
336
337 # Build an individual diff.
338 build_diff() {
339   changedir "${WORKING_DIRECTORY}"
340   tmpdir=gccdiff.$$
341   mkdir $tmpdir || error "Could not create directory $tmpdir"
342   changedir $tmpdir
343   (${BZIP2} -d -c $1 | ${TAR} xf - ) || error "Could not unpack $1 for diffs"
344   (${BZIP2} -d -c $3 | ${TAR} xf - ) || error "Could not unpack $3 for diffs"
345   ${DIFF} $2 $4 > ../${5%.bz2}
346   if [ $? -eq 2 ]; then
347     error "Trouble making diffs from $1 to $3"
348   fi
349   ${BZIP2} ../${5%.bz2} || error "Could not generate ../$5"
350   changedir ..
351   rm -rf $tmpdir
352   FILE_LIST="${FILE_LIST} $5"
353 }
354
355 # Upload the files to the FTP server.
356 upload_files() {
357   inform "Uploading files"
358
359   changedir "${WORKING_DIRECTORY}"
360
361   # Make sure the directory exists on the server.
362   if [ $LOCAL -eq 0 ]; then
363     ${SSH} -l ${GCC_USERNAME} ${GCC_HOSTNAME} \
364       mkdir -p "${FTP_PATH}/diffs"
365     UPLOAD_PATH="${GCC_USERNAME}@${GCC_HOSTNAME}:${FTP_PATH}"
366   else
367     mkdir -p "${FTP_PATH}/diffs" \
368       || error "Could not create \`${FTP_PATH}'"
369     UPLOAD_PATH=${FTP_PATH}
370   fi
371
372   # Then copy files to their respective (sub)directories.
373   for x in gcc*.gz gcc*.bz2; do
374     if [ -e ${x} ]; then
375       # Make sure the file will be readable on the server.
376       chmod a+r ${x}
377       # Copy it.
378       case ${x} in
379         *.diff.*)
380           SUBDIR="diffs/";
381           ;;
382         *)
383           SUBDIR="";
384       esac
385       ${SCP} ${x} ${UPLOAD_PATH}/${SUBDIR} \
386         || error "Could not upload ${x}"
387     fi
388   done
389 }
390
391 # Announce a snapshot, both on the web and via mail.
392 announce_snapshot() {
393   inform "Updating links and READMEs on the FTP server"
394   
395   TEXT_DATE=`date --date=$DATE +%B\ %d,\ %Y`
396   cd ~ftp/pub/gcc/snapshots
397   sed -e "s%@DATE@%$DATE%g" \
398      -e "s%@LAST_DATE@%$LAST_DATE%g" \
399     -e "s%@BRANCH@%${BRANCH}%g" \
400     -e "s%@RELEASE@%${RELEASE}%g" \
401     -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-README > $$
402   mv $$ ${RELEASE}/README
403   sed -e "s%@DATE@%$DATE%g" \
404      -e "s%@LAST_DATE@%$LAST_DATE%g" \
405     -e "s%@BRANCH@%${BRANCH}%g" \
406     -e "s%@RELEASE@%${RELEASE}%g" \
407     -e "s%@TEXT_DATE@%$TEXT_DATE%g" < ~/scripts/snapshot-index.html > $$
408   mv $$ ${RELEASE}/index.html
409
410   touch LATEST-IS-${BRANCH}-${DATE}
411   rm -f LATEST-IS-${BRANCH}-${LAST_DATE}
412
413   inform "Sending mail"
414
415   export QMAILHOST=gcc.gnu.org
416   mail -s "gcc-ss-${RELEASE} is now available" gcc@gcc.gnu.org < ~ftp/pub/gcc/snapshots/${RELEASE}/README
417 }
418
419 ########################################################################
420 # Initialization
421 ########################################################################
422
423 # Today's date.
424 DATE=`date "+%Y%m%d"`
425 LONG_DATE=`date "+%Y-%m-%d"`
426
427 # The CVS server containing the GCC repository.
428 CVS_SERVER="gcc.gnu.org"
429 # The path to the repository on that server.
430 CVS_REPOSITORY="/cvs/gcc"
431 # The CVS protocol to use.
432 CVS_PROTOCOL="ext"
433 # The username to use when connecting to the server.
434 CVS_USERNAME="${USER}"
435
436 # The machine to which files will be uploaded.
437 GCC_HOSTNAME="gcc.gnu.org"
438 # The name of the account on the machine to which files are uploaded.
439 GCC_USERNAME="gccadmin"
440 # The directory in which the files will be placed.
441 FTP_PATH="~ftp/pub/gcc"
442
443 # The major number for the release.  For release `3.0.2' this would be 
444 # `3'
445 RELEASE_MAJOR=""
446 # The minor number for the release.  For release `3.0.2' this would be
447 # `0'.
448 RELEASE_MINOR=""
449 # The revision number for the release.  For release `3.0.2' this would
450 # be `2'.
451 RELEASE_REVISION=""
452 # The complete name of the release.
453 RELEASE=""
454
455 # The name of the branch from which the release should be made, in a 
456 # user-friendly form.
457 BRANCH=""
458
459 # The name of the branch from which the release should be made, as used
460 # for our version control system.
461 CVSBRANCH=""
462
463 # The tag to apply to the sources used for the release.
464 TAG=""
465
466 # The old tarballs from which to generate diffs.
467 OLD_TARS=""
468
469 # The directory that will be used to construct the release.  The
470 # release itself will be placed in a subdirectory of this diretory.
471 DESTINATION=${HOME}
472 # The subdirectory.
473 WORKING_DIRECTORY=""
474 # The directory that will contain the GCC sources.
475 SOURCE_DIRECTORY=""
476
477 # The directories that should be part of the various language-specific
478 # tar files.  These are all relative to the top of the source tree.
479 ADA_DIRS="gcc/ada"
480 CPLUSPLUS_DIRS="gcc/cp libstdc++-v3"
481 FORTRAN_DIRS="gcc/f libf2c"
482 JAVA_DIRS="gcc/java libjava libffi fastjar zlib boehm-gc"
483 OBJECTIVEC_DIRS="gcc/objc libobjc"
484 TESTSUITE_DIRS="gcc/testsuite"
485
486 # Non-zero if this is the final release, rather than a prerelease.
487 FINAL=0
488
489 # Non-zero if we are building a snapshot, and don't build gcc or
490 # include generated files.
491 SNAPSHOT=0
492
493 # Non-zero if we are running locally on gcc.gnu.org, and use local CVS
494 # and copy directly to the FTP directory.
495 LOCAL=0
496
497 # Major operation modes.
498 MODE_GZIP=0
499 MODE_DIFFS=0
500 MODE_SOURCES=0
501 MODE_TARFILES=0
502 MODE_UPLOAD=0
503
504 # List of archive files generated; used to create .gz files from .bz2.
505 FILE_LIST=""
506
507 # Programs we use.
508
509 BZIP2="${BZIP2:-bzip2}"
510 CVS="${CVS:-cvs -f -Q -z9}"
511 DIFF="${DIFF:-diff -Nrc3pad}"
512 ENV="${ENV:-env}"
513 GZIP="${GZIP:-gzip --best}"
514 SCP="${SCP:-scp -p}"
515 SSH="${SSH:-ssh}"
516 TAR="${TAR:-tar}"
517
518 ########################################################################
519 # Command Line Processing
520 ########################################################################
521
522 # Parse the options.
523 while getopts "d:fr:u:t:p:s:l" ARG; do
524     case $ARG in
525     d)    DESTINATION="${OPTARG}";;
526     r)    RELEASE="${OPTARG}";;
527     t)    TAG="${OPTARG}";;
528     u)    CVS_USERNAME="${OPTARG}";;
529     f)    FINAL=1;;
530     s)    SNAPSHOT=1
531           BRANCH=${OPTARG%:*}
532           CVSBRANCH=${OPTARG#*:}
533           ;;
534     l)    LOCAL=1
535           SCP=cp
536           FTP_PATH=~ftp/pub/gcc
537           PATH=~:/usr/local/bin:$PATH;;
538     p)    OLD_TARS="${OLD_TARS} ${OPTARG}"
539           if [ -d ${OPTARG} ]; then
540             error "-p argument must name a tarball"
541           fi;;
542     \?)   usage;;
543     esac
544 done
545 shift `expr ${OPTIND} - 1`
546
547 # Handle the major modes.
548 while [ $# -ne 0 ]; do
549     case $1 in
550     diffs)    MODE_DIFFS=1;;
551     gzip)     MODE_GZIP=1;;
552     sources)  MODE_SOURCES=1;;
553     tarfiles) MODE_TARFILES=1;;
554     upload)   MODE_UPLOAD=1;;
555     all)      MODE_SOURCES=1; MODE_TARFILES=1; MODE_DIFFS=1; MODE_UPLOAD=1;
556               if [ $SNAPSHOT -ne 1 ]; then
557                 # Only for releases and pre-releases.
558                 MODE_GZIP=1;
559               fi
560               ;;
561     *)        error "Unknown mode $1";;
562     esac
563     shift
564 done
565
566 # Perform consistency checking.
567 if [ ${LOCAL} -eq 0 ] && [ -z ${CVS_USERNAME} ]; then
568   error "No username specified"
569 fi
570
571 if [ ! -d ${DESTINATION} ]; then
572   error "\`${DESTINATION}' is not a directory"
573 fi
574
575 if [ $SNAPSHOT -eq 0 ]; then
576   if [ -z ${RELEASE} ]; then
577     error "No release number specified"
578   fi
579
580   # Compute the major and minor release numbers.
581   RELEASE_MAJOR=`echo $RELEASE | awk --assign FS=. '{ print $1; }'`
582   RELEASE_MINOR=`echo $RELEASE | awk --assign FS=. '{ print $2; }'`
583   RELEASE_REVISION=`echo $RELEASE | awk --assign FS=. '{ print $3; }'`
584
585   if [ -z "${RELEASE_MAJOR}" ] || [ -z "${RELEASE_MINOR}" ]; then
586     error "Release number \`${RELEASE}' is invalid"
587   fi
588
589   # Compute the full name of the release.
590   if [ -z "${RELEASE_REVISION}" ]; then
591     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}"
592   else
593     RELEASE="${RELEASE_MAJOR}.${RELEASE_MINOR}.${RELEASE_REVISION}"
594   fi
595
596   # Compute the name of the branch, which is based solely on the major
597   # and minor release numbers.
598   CVSBRANCH="gcc-${RELEASE_MAJOR}_${RELEASE_MINOR}-branch"
599
600   # If this is not a final release, set various parameters acordingly.
601   if [ ${FINAL} -ne 1 ]; then
602     RELEASE="${RELEASE}-${DATE}"
603     FTP_PATH="${FTP_PATH}/prerelease-${RELEASE}/"
604   else
605     FTP_PATH="${FTP_PATH}/releases/gcc-${RELEASE}/"
606   fi
607 else
608   RELEASE=${BRANCH}-${DATE}
609   FTP_PATH="${FTP_PATH}/snapshots/${RELEASE}"
610   if [ ${CVSBRANCH} != "HEAD" ]; then
611     TAG=gcc-ss-`echo ${RELEASE} | tr '.' '_'`
612   fi
613
614   # Building locally on gcc.gnu.org, we know what the last snapshot date
615   # was.
616   if [ $MODE_DIFFS -ne 0 ] && [ $LOCAL -ne 0 ]; then
617     LAST_DATE=`cat ~/.snapshot_date-${BRANCH}`
618     LAST_DIR=~ftp/pub/gcc/snapshots/${BRANCH}-${LAST_DATE}
619     OLD_TARS=${LAST_DIR}/gcc-${BRANCH}-${LAST_DATE}.tar.bz2
620   fi
621 fi
622
623 # Compute the name of the WORKING_DIRECTORY and the SOURCE_DIRECTORY.
624 WORKING_DIRECTORY="${DESTINATION}/gcc-${RELEASE}"
625 SOURCE_DIRECTORY="${WORKING_DIRECTORY}/gcc-${RELEASE}"
626
627 # Recompute the names of all the language-specific directories,
628 # relative to the WORKING_DIRECTORY.
629 ADA_DIRS=`adjust_dirs ${ADA_DIRS}`
630 CPLUSPLUS_DIRS=`adjust_dirs ${CPLUSPLUS_DIRS}`
631 FORTRAN_DIRS=`adjust_dirs ${FORTRAN_DIRS}`
632 JAVA_DIRS=`adjust_dirs ${JAVA_DIRS}`
633 OBJECTIVEC_DIRS=`adjust_dirs ${OBJECTIVEC_DIRS}`
634 TESTSUITE_DIRS=`adjust_dirs ${TESTSUITE_DIRS}`
635
636 # Set up CVSROOT.
637 if [ $LOCAL -eq 0 ]; then
638     CVSROOT=":${CVS_PROTOCOL}:${CVS_USERNAME}@"
639     CVSROOT="${CVSROOT}${CVS_SERVER}:${CVS_REPOSITORY}"
640 else
641     CVSROOT="${CVS_REPOSITORY}"
642 fi
643 export CVSROOT
644
645 ########################################################################
646 # Main Program
647 ########################################################################
648
649 # Set the timezone to UTC
650 TZ="UTC0"
651 export TZ
652
653 # Build the source directory.
654
655 if [ $MODE_SOURCES -ne 0 ]; then
656   build_sources
657 fi
658
659 # Build the tar files.
660
661 if [ $MODE_TARFILES -ne 0 ]; then
662   build_tarfiles
663 fi
664
665 # Build diffs
666
667 if [ $MODE_DIFFS -ne 0 ]; then
668   # Possibly build diffs.
669   if [ -n "$OLD_TARS" ]; then
670     for old_tar in $OLD_TARS; do
671       build_diffs $old_tar
672     done
673   fi
674 fi
675
676 # Build gzip files
677 if [ $MODE_GZIP -ne 0 ]; then
678   build_gzip
679 fi
680
681 # Upload them to the FTP server.
682
683 if [ $MODE_UPLOAD -ne 0 ]; then
684   upload_files
685
686   # For snapshots, make some further updates.
687   if [ $SNAPSHOT -ne 0 ] && [ $LOCAL -ne 0 ]; then
688     announce_snapshot
689
690     # Update snapshot date file.
691     changedir ~
692     echo $DATE > .snapshot_date-${BRANCH}
693
694     # Remove working directory
695     rm -rf ${WORKING_DIRECTORY}
696   fi
697 fi